package org.dbgl.gui.controls;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;


public class List_ {

	private final org.eclipse.swt.widgets.List list_;

	private List_(Builder builder) {
		list_ = new org.eclipse.swt.widgets.List(builder.composite_, builder.style_);
		if (DarkTheme.forced()) {
			list_.setBackground(DarkTheme.inputBackground);
			list_.setForeground(DarkTheme.defaultForeground);
		}
		list_.setLayoutData(builder.layoutData());

		if (builder.items_ != null)
			list_.setItems(builder.items_);
		if (builder.select_ >= 0) {
			list_.select(builder.select_);
			list_.showSelection();
		}
	}

	public org.eclipse.swt.widgets.List ctrl() {
		return list_;
	}

	public static Builder on(Composite composite) {
		return new Builder(composite);
	}

	public static class Builder extends ControlBuilder<Builder> {
		String[] items_;
		int select_ = -1;

		Builder(Composite composite) {
			super(composite, SWT.BORDER | SWT.V_SCROLL, SWT.FILL, SWT.FILL, true, true);
		}

		public Builder multi() {
			style_ |= SWT.MULTI;
			return this;
		}

		public Builder items(String[] items) {
			items_ = items;
			return this;
		}

		public Builder select(int select) {
			select_ = select;
			return this;
		}

		public List_ build() {
			return new List_(this);
		}

		public org.eclipse.swt.widgets.List ctrl() {
			return build().ctrl();
		}
	}
}
